
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>【Android】触屏事件传递简述 / 憋错料</title>

    <meta name="description" content="【Android】触屏事件传递简述 一个典型的结构模型 ActivityA包含ViewGroupB,ViewGroupB包含ViewC,这里选取ViewGroupB(中间节点)作为当前节点视角 过程一:当前节点与父节点的事件关系 ActivityA只关心ViewGroupB.onDispatchTouchEvent返回值,只要在ACTION_DOWN分发过程中B.onDispatchTouchEvent()返回为true,那么后续的事件都会向B分发.至于ViewGroupB在onDispatchTouchEvent方法中是怎么处理">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">【Android】触屏事件传递简述</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<h2>一个典型的结构模型</h2>
<p>ActivityA包含ViewGroupB，ViewGroupB包含ViewC，这里选取ViewGroupB（中间节点）作为当前节点视角</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvc3RhdGljLm9zY2hpbmEubmV0L3VwbG9hZHMvc3BhY2UvMjAxNS8wNDA3LzAxNTA0Ml9weGJYXzkzNjg4LnBuZw==.jpg"></p>
<h2>过程一：当前节点与父节点的事件关系</h2>
<p>ActivityA只关心ViewGroupB.onDispatchTouchEvent返回值，只要在ACTION_DOWN分发过程中B.onDispatchTouchEvent()返回为true，那么后续的事件都会向B分发。至于ViewGroupB在onDispatchTouchEvent方法中是怎么处理的，父节点ActivityA并不会过问。</p>
<p>换句话说，父节点向<strong><em>直接子节点ViewGroupB</em></strong>兜售ACTION_DOWN事件，子节点使用onDispatchTouchEvent方法的返回值进行应答，只要子节点表示能够处理ACTION_DOWN，那么父节点就会将后续事件持续交给子节点。</p>
<h2>过程二：当前节点与子节点的事件关系</h2>
<p>ViewGroupB从上一级收到ACTION_DOWN事件之后，会调用onInterceptTouchEvent判断是否进行拦截。如果不拦截，那么流程与上面的“过程一”一致，如果拦截，那么ViewGroupB就吃掉事件，直接忽略ViewC。</p>
<p>不过onInterceptTouchEvent属于内部方法，这个方法本身并不会影响当前节点的onDispatchTouchEvent返回值。</p>
<h2>onDispatchTouchEvent返回值的判断</h2>
<p>通常情况下，一个节点的onDispatchTouchEvent返回值只与当前节点的onTouchEvent返回值和子节点的onDispatchTouchEvent返回值有关：</p>
<pre><code>this.onDispatchTouchEventValue = child.onDispatchTouchEventValue || this.onTouchEvent
</code></pre>
<p>当然，也可以强制给onDispatchTouchEvent赋一个返回值，尽管如此，也不应该强制抛弃原有的事件机制，因为原有的事件机制会进行一些状态清理等操作。</p>
<p>ACTION_DOWN示例图： <br /><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvc3RhdGljLm9zY2hpbmEubmV0L3VwbG9hZHMvc3BhY2UvMjAxNS8wNDA3LzAxNTA1N182MDZ6XzkzNjg4LnBuZw==.jpg"></p>
<h4>Android分享 Q群：315658668</h4>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-06 00:56:49 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>【Android】触屏事件传递简述的相关文章</h3>

						<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3Ob5JK0.html" rel="bookmark">Android触屏事件传递（个人实践总结）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Android触屏事件传递 一:前言 之前由于做Launcher部分,涉及到许多交互的部分,因为项目过去很长时间了,最近又在做GTS,CTS的测试与修改,好多都不熟悉甚至忘记了,结合别人的文章经验(我发现有些地方和别人有出入,但自己经测试验证),加上自己的测试,今天写下文章来总结一下. 二:关于ViewGroup与其中的view视图 ViewGroup是一个容器类,一般,布局容器是继承字它的.容器里面可以存放视图,当然也可以嵌套容器,比如Relativelayout,LinearLayout等等			</div>
		</article>
	</section>
						<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MDnJln3.html" rel="bookmark">Android 触屏事件 OnTouch onClick onTouchEvent对于触屏事件的处理和分发</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Android 触屏事件 OnTouch onClick onTouchEvent对于触屏事件的处理和分发 做项目的时候经常遇到需要事件分发,很多时候我们发现当我们触发了onTouch却触发不了onClick.或者触发了View的事件却触发不了ViewGroup的事件.那么他们之间到底是什么关系呢,其实最终他们涉及的只是两个问题 OnTouch .onClick .onTouchEvent 之间的关系 OnTouch .onClick .onTouchEvent 之间的处理顺序 这里,我做了简单			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0aOg7J4.html" rel="bookmark">Android的触屏事件</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Android系统中的每个View的子类都包含的三种和touchevent有关的三种方法. ondispathTouchEvent(); 这个方法用来分发TouchEventonInterceptTouchEvent(); 这个方法用来拦截TouchEventonTouchEvent: 这个方法用来处理TouchEvent 每次触屏事件,都有最顶层的View的ondispathTouchEvent()接受,由这个方法进行分发.当方法返回true时 ,就将触屏事件传递给该View的OntouchE			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4JGglPM.html" rel="bookmark">android实现横竖屏8个方向触屏事件的捕捉并有相对应的动画提示</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1:首先来说横竖屏的问题 这里我是在onCreate方法中直接强制横屏竖屏的设置, Button btn; SurfaceView surfaceView; //初始化布局 protected void onCreate(Bundle savedInstanceState) { super.onCreate(savedInstanceState); setContentView(R.layout.activity_main); init(); addListener(); } //初始化 pri			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MWe1kG3.html" rel="bookmark">转&colon;Android随笔之&mdash;&mdash;使用Root权限实现后台模拟全局按键、触屏事件方法（类似按键精灵）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文转载自CSDN的jzj1993,原文连接:http://blog.csdn.net/jzj1993/article/details/39158865 有时我们需要使用安卓实现在后台模拟系统按键,比如对音量进行调节(模拟音量键),关闭前台正在运行的App(模拟返回键),或者模拟触屏事件.但是对于原生安卓系统而言,后台进程关闭前台进程,甚至模拟用户事件,进而操控整个系统,是不符合系统安全原则的,如果有这样的漏洞被病毒或恶意软件所利用,会非常危险. 由于一些特殊原因,我恰巧需要实现这样的功能,而又			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MGGBJYM.html" rel="bookmark">舌尖上的安卓&lpar;android触控事件机制学习笔记录&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				对于一个&quot;我们从来不生产代码,我们只是大自然代码的搬运工&quot;的码农来说.对android的触控机制一直是模棱两可的状态,特别是当要求一些自定义的控件和androide的自带控件(比如ViewPager,ListView,ScrollView)高度嵌套在一起使用时. 花了点时间梳理了下,做个笔记.对于一个触控的事件从用户输入到传递到Actigvity到最外层的Viewgroup在到子View,中间过程还可能穿插多个Viewgroup,android在ViewGroup提供了3个方法来控制流			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MPvQzB3.html" rel="bookmark">移动端touch触屏滑动事件、滑动触屏事件监听！</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				移动端touch触屏滑动事件.滑动触屏事件监听! 一.触摸事件 ontouchstart.ontouchmove.ontouchend.ontouchcancel 目前移动端浏览器均支持这4个触摸事件,包括IE.由于触屏也支持MouseEvent,因此他们的顺序是需要注意的:touchstart → mouseover → mousemove → mousedown → mouseup → click1 Apple在iOS 2.0中引入了触摸事件API,Android正迎头赶上这一事实标准,缩小			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MXZbba3.html" rel="bookmark">Android&colon; 触屏fling&sol;scroll&sol;drag的区别及其详细过程</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Google了一下,终于搞清了touch screen下的几种操作模式(对应的是事件). 对于一个view, 常用的操作有点击(click)和长按(long press)二种.实际上,这些操作类型是Android内部在onTouchEvent(MotionEvent event)里对用户的动作做了一定的分析,从而通知应用程序是发生了点击还是长按等事件. 有时,我们需要的并不仅限于这两种操作.我们可以借助GestureDetector来分析出更细致的操作类型.基本的过程就是创建一个myGestur			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MoX2rD0.html" rel="bookmark">View实现事件监听DEMO（文本跟随触屏事件）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				View 是一个显示的视图,内置的画布通过重写Ondraw(Canvas canvas);方法获得,同时提供图形绘制函数.触屏事件.按键事件等. 现在利用一个简单的demo演示一下几个重要的常用到的方法: import android.content.Context; import android.graphics.Canvas; import android.graphics.Color; import android.graphics.Paint; import android.view.K			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4QWq9B0.html" rel="bookmark" class="title">算法笔记</a>
					<div>
						给定n个数,以及数k,判断是否能够从n个数中找出任意个数,使其和等于k 1 #include&lt;iostream&gt; 2 #include&lt;malloc.h&gt; 3 using na ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MoQ6ox3.html" rel="bookmark" class="title">利用datafile copy将数据文件重命名</a>
					<div>
						思路: o 利用RMAN对数据文件做copy o 将数据文件offline o switch文件名,这一步将更改控制文件中数据文件对应的文件名 o recover数据文件 o 将数据文件online, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MDROB93.html" rel="bookmark" class="title">mysql 注意点</a>
					<div>
						mysql 优化: 每个innodb 表都要有一个主键限制表上索引的数量,避免建立重复和冗余索引注意合理选择复合索引键值的顺序 优先选择符合存储需要的最小的数据类型 varchar(N) 中的N 代表 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/My57OaM.html" rel="bookmark" class="title">掠那雇犯岩文丈呈</a>
					<div>
						http://www.itouxian.com/152511 http://www.itouxian.com/8t0bndi2 http://www.itouxian.com/152513 http: ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4JkL89M.html" rel="bookmark" class="title">Java transient 关键字</a>
					<div>
						1)一旦变量被transient修饰,变量将不再是对象持久化的一部分,该变量内容在序列化后无法获得访问. 2)transient关键字只能修饰变量,而不能修饰方法和类.注意,本地变量是不能被trans ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4AmgZZ4.html" rel="bookmark" class="title">androd输入管理系统机制解析</a>
					<div>
						﻿﻿ android的输入管理系统主要完成按键.触摸板.鼠标等输入设备的事件输入,功能包括,输入设备的事件输入及向焦点窗口和焦点视图的事件派发,事件的插入,事件的过滤,事件的拦截等功能. 整个输入系统 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4JykOb3.html" rel="bookmark" class="title">猪猪的机器学习笔记（十八）条件随机场</a>
					<div>
						条件随机场 作者:樱花猪 摘要: 本文为七月算法(julyedu.com)12月机器学习第十八次课在线笔记.条件随机场是一种判别式概率模型,是随机场的一种,常用于标注或分析序列资料,如自然语言文字或是 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MzAyKq4.html" rel="bookmark" class="title">shell text code</a>
					<div>
						shell 命令处理文本: 1. 批量处理该目录下的文件,ls | while read l ; do echo $l ; done &gt; b.txt 2. 批量处理文件的每一行 , cut -f ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0KO6YJ0.html" rel="bookmark" class="title">枚举的使用</a>
					<div>
						package enhance; /** * Created by coolkid on 2014/12/20 0020. */ public class EnumTest { public stat ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3v57GL0.html" rel="bookmark" class="title">xampp如何设置多虚拟主机访问</a>
					<div>
						D:\xampp\htdocs\project\TPDev\abc 如果我想访问project/目录,地址栏:localhost/project是不是很麻烦?直接pj.com是不是更简单一点!直接进入 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3ZNpzL3.html" rel="bookmark" class="title">python学习-基础-异常处理</a>
					<div>
						异常: 异常(exception):因运行时错误而出现,会产生一个traceback &quot;traceback&quot;是出现的运行时错误的一个详细描述 常见异常:(待完善) 数据不符合期望的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0KZxkYM.html" rel="bookmark" class="title">pxe详解</a>
					<div>
						一.PXE到底是什么东东? PXE(Preboot Execution Environment) 预启动执行环境 是由Intel设计的协议,它可以使计算机通过网络启动.协议分为client和serve ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0xZbbr4.html" rel="bookmark" class="title">课后题1</a>
					<div>
											</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4AEpaD4.html" rel="bookmark" class="title">APP有奖征集活动（更多给力奖品等您来拿）</a>
					<div>
						APP有奖征集活动        APICloud为感谢各位开发者对我们的支持,现在发起APP征集奖励活动.您可以直接提交您在APICloud开发完成的项目:如果没有已完成的项目,攻城师可以从资讯类. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MgR5Q84.html" rel="bookmark" class="title">03&period;值类型和引用类型</a>
					<div>
						区别: 1.值类型和引用类型在内存上存储的地方不一样 2.在传递至类型和传递引用类型的时候,传递的方式不一样. 值类型,我们称之为值传递,引用类型我们称之为引用传递. 值类型:int,double,d ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0az29R3.html" rel="bookmark" class="title">简单的实现快速排序（适合小白入门）</a>
					<div>
						1 /* 2 此篇博文适用于像我一样的小白: 3 首先,你要大概了了解快排的基本原理: 4 快排的实现有网上很多种,我自认为下面这种相对好理解的: 5 废话不多说,上代码: 6 注:下面的实现对数组元 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3rBe5w3.html" rel="bookmark" class="title">Java基础知识强化之IO流笔记45：IO流练习之 把集合中的数据存储到文本文件案例</a>
					<div>
						1. 把集合中的数据存储到文本文件案例:    需求:把ArrayList集合中的字符串数据存储到文本文件 ? (1)分析:通过题目的意思我们可以知道如下的一些内容,ArrayList集合里存储的是字 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/47XN9kM.html" rel="bookmark" class="title">关于Qt移植arm上点击没反应&comma;箭头也不动的问题</a>
					<div>
						关于Qt的移植,以前移植过一次S3C2440的.现在这平台是AT91SAM9X35的.不过移植过程都一样,只不过遇到了以前没遇到的事情,在此记录下来 平台:AT91SAM9X35 环境:linux-2 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0d2Byg4.html" rel="bookmark" class="title">BuckleScript 教程：面向 OCaml 的 JavaScript</a>
					<div>
						BuckleScript 1.0 发布了,BuckleScript最初是以名称OcamlScript发布的,后来为了避免同另一个项目混淆而改名(腾云科技TY300.COM).BuckleScript由 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0nejOoM.html" rel="bookmark" class="title">&lbrack;效率神技&rsqb;Intellij 的快捷键和效率技巧&vert;系列一&vert;常用快捷键</a>
					<div>
						Intellij 是个功能强大的IDE,这里只讲window下社区版的Intellij. 1. 常用快捷: Alt+回车 导入包,自动修正Ctrl+N   查找类Ctrl+Shift+N 查找文件Ct ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.024 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
